#include <iostream> // library for printing
#include <string>   // support for strings
#include <vector>   // support for vectors
#include <assert.h>
using namespace std;

// For compiling C++ code
// g++ a.c -o a
struct Grid
{
  Grid(string n) {
    name = n;
  }
  int rows() const { return lines.size(); }
  int cols() const { 
    if (lines.empty()) {
      return 0;
    } else {
      return lines[0].size(); }
    }
  void Load() {
    lines.push_back("DOG....");
    lines.push_back("---....");
    lines.push_back("----...");
    lines.push_back("-------");
    lines.push_back("...----");
    lines.push_back("....---");
    lines.push_back("....CAT");
  }
  void Check() const {
    for (string s : lines)
    {
      assert(s.size() == cols());
    }
  }
  void Print() const {
    cout << "Grid: " << name
        << " (rows=" << rows()
        << ", cols=" << cols() << ")\n";
    for (string s : lines) {
      cout << "  " << s << "\n";
    }
  }
  string name; // string are initialized empty
  vector<string> lines;
};

int main()
{
  Grid grid("MY GRID");

  grid.Load();
  grid.Check();
  grid.Print();
}